/*
* Copyright (C) 2024, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: iaom <zhangpengfei@kylinos.cn>
 *
 */
#ifndef DT_THEME_H
#define DT_THEME_H

#include <QObject>
#include <QColor>
#include <QQmlEngine>

namespace UkuiQuick {

class DtThemePrivate;
//TODO 可通过AttachedProperty的方式将DtTheme注册,支持在qml中直接创建DtTheme类实现自定义token
class DtTheme : public QObject
{
    Q_OBJECT
    Q_PROPERTY(QColor windowTextActive READ windowTextActive NOTIFY windowTextActiveChanged)
    Q_PROPERTY(QColor windowTextInactive READ windowTextInactive NOTIFY windowTextInactiveChanged)
    Q_PROPERTY(QColor windowTextDisable READ windowTextDisable NOTIFY windowTextDisableChanged)
    Q_PROPERTY(QColor buttonActive READ buttonActive NOTIFY buttonActiveChanged)
    Q_PROPERTY(QColor buttonInactive READ buttonInactive NOTIFY buttonInactiveChanged)
    Q_PROPERTY(QColor buttonDisable READ buttonDisable NOTIFY buttonDisableChanged)
    Q_PROPERTY(QColor lightActive READ lightActive NOTIFY lightActiveChanged)
    Q_PROPERTY(QColor lightInactive READ lightInactive NOTIFY lightInactiveChanged)
    Q_PROPERTY(QColor lightDisable READ lightDisable NOTIFY lightDisableChanged)
    Q_PROPERTY(QColor darkActive READ darkActive NOTIFY darkActiveChanged)
    Q_PROPERTY(QColor darkInactive READ darkInactive NOTIFY darkInactiveChanged)
    Q_PROPERTY(QColor darkDisable READ darkDisable NOTIFY darkDisableChanged)
    Q_PROPERTY(QColor baseActive READ baseActive NOTIFY baseActiveChanged)
    Q_PROPERTY(QColor baseInactive READ baseInactive NOTIFY baseInactiveChanged)
    Q_PROPERTY(QColor baseDisable READ baseDisable NOTIFY baseDisableChanged)
    Q_PROPERTY(QColor midLightActive READ midLightActive NOTIFY midLightActiveChanged)
    Q_PROPERTY(QColor midLightInactive READ midLightInactive NOTIFY midLightInactiveChanged)
    Q_PROPERTY(QColor midLightDisable READ midLightDisable NOTIFY midLightDisableChanged)
    Q_PROPERTY(QColor midActive READ midActive NOTIFY midActiveChanged)
    Q_PROPERTY(QColor midInactive READ midInactive NOTIFY midInactiveChanged)
    Q_PROPERTY(QColor midDisable READ midDisable NOTIFY midDisableChanged)
    Q_PROPERTY(QColor textActive READ textActive NOTIFY textActiveChanged)
    Q_PROPERTY(QColor textInactive READ textInactive NOTIFY textInactiveChanged)
    Q_PROPERTY(QColor textDisable READ textDisable NOTIFY textDisableChanged)
    Q_PROPERTY(QColor brightTextActive READ brightTextActive NOTIFY brightTextActiveChanged)
    Q_PROPERTY(QColor brightTextInactive READ brightTextInactive NOTIFY brightTextInactiveChanged)
    Q_PROPERTY(QColor brightTextDisable READ brightTextDisable NOTIFY brightTextDisableChanged)
    Q_PROPERTY(QColor buttonTextActive READ buttonTextActive NOTIFY buttonTextActiveChanged)
    Q_PROPERTY(QColor buttonTextInactive READ buttonTextInactive NOTIFY buttonTextInactiveChanged)
    Q_PROPERTY(QColor buttonTextDisable READ buttonTextDisable NOTIFY buttonTextDisableChanged)
    Q_PROPERTY(QColor baseActive READ baseActive NOTIFY baseActiveChanged)
    Q_PROPERTY(QColor baseInactive READ baseInactive NOTIFY baseInactiveChanged)
    Q_PROPERTY(QColor baseDisable READ baseDisable NOTIFY baseDisableChanged)
    Q_PROPERTY(QColor windowActive READ windowActive NOTIFY windowActiveChanged)
    Q_PROPERTY(QColor windowInactive READ windowInactive NOTIFY windowInactiveChanged)
    Q_PROPERTY(QColor windowDisable READ windowDisable NOTIFY windowDisableChanged)
    Q_PROPERTY(QColor shadowActive READ shadowActive NOTIFY shadowActiveChanged)
    Q_PROPERTY(QColor shadowInactive READ shadowInactive NOTIFY shadowInactiveChanged)
    Q_PROPERTY(QColor shadowDisable READ shadowDisable NOTIFY shadowDisableChanged)
    Q_PROPERTY(QColor highlightActive READ highlightActive NOTIFY highlightActiveChanged)
    Q_PROPERTY(QColor highlightInactive READ highlightInactive NOTIFY highlightInactiveChanged)
    Q_PROPERTY(QColor highlightDisable READ highlightDisable NOTIFY highlightDisableChanged)
    Q_PROPERTY(QColor linkActive READ linkActive NOTIFY linkActiveChanged)
    Q_PROPERTY(QColor linkInactive READ linkInactive NOTIFY linkInactiveChanged)
    Q_PROPERTY(QColor linkDisable READ linkDisable NOTIFY linkDisableChanged)
    Q_PROPERTY(QColor linkVisitedActive READ linkVisitedActive NOTIFY linkVisitedActiveChanged)
    Q_PROPERTY(QColor linkVisitedInactive READ linkVisitedInactive NOTIFY linkVisitedInactiveChanged)
    Q_PROPERTY(QColor linkVisitedDisable READ linkVisitedDisable NOTIFY linkVisitedDisableChanged)
    Q_PROPERTY(QColor alternateBaseActive READ alternateBaseActive NOTIFY alternateBaseActiveChanged)
    Q_PROPERTY(QColor alternateBaseInactive READ alternateBaseInactive NOTIFY alternateBaseInactiveChanged)
    Q_PROPERTY(QColor alternateBaseDisable READ alternateBaseDisable NOTIFY alternateBaseDisableChanged)
    Q_PROPERTY(QColor noRoleActive READ noRoleActive NOTIFY noRoleActiveChanged)
    Q_PROPERTY(QColor noRoleInactive READ noRoleInactive NOTIFY noRoleInactiveChanged)
    Q_PROPERTY(QColor noRoleDisable READ noRoleDisable NOTIFY noRoleDisableChanged)
    Q_PROPERTY(QColor toolTipBaseActive READ toolTipBaseActive NOTIFY toolTipBaseActiveChanged)
    Q_PROPERTY(QColor toolTipBaseInactive READ toolTipBaseInactive NOTIFY toolTipBaseInactiveChanged)
    Q_PROPERTY(QColor toolTipBaseDisable READ toolTipBaseDisable NOTIFY toolTipBaseDisableChanged)
    Q_PROPERTY(QColor toolTipTextActive READ toolTipTextActive NOTIFY toolTipTextActiveChanged)
    Q_PROPERTY(QColor toolTipTextInactive READ toolTipTextInactive NOTIFY toolTipTextInactiveChanged)
    Q_PROPERTY(QColor toolTipTextDisable READ toolTipTextDisable NOTIFY toolTipTextDisableChanged)
    Q_PROPERTY(QColor placeholderTextActive READ placeholderTextActive NOTIFY placeholderTextActiveChanged)
    Q_PROPERTY(QColor placeholderTextInactive READ placeholderTextInactive NOTIFY placeholderTextInactiveChanged)
    Q_PROPERTY(QColor placeholderTextDisable READ placeholderTextDisable NOTIFY placeholderTextDisableChanged)
    Q_PROPERTY(QColor kWhite READ kWhite NOTIFY kWhiteChanged)
    Q_PROPERTY(QColor kBlack READ kBlack NOTIFY kBlackChanged)
    Q_PROPERTY(QColor kGray0 READ kGray0 NOTIFY kGray0Changed)
    Q_PROPERTY(QColor kGray1 READ kGray1 NOTIFY kGray1Changed)
    Q_PROPERTY(QColor kGray2 READ kGray2 NOTIFY kGray2Changed)
    Q_PROPERTY(QColor kGray3 READ kGray3 NOTIFY kGray3Changed)
    Q_PROPERTY(QColor kGray4 READ kGray4 NOTIFY kGray4Changed)
    Q_PROPERTY(QColor kGray5 READ kGray5 NOTIFY kGray5Changed)
    Q_PROPERTY(QColor kGray6 READ kGray6 NOTIFY kGray6Changed)
    Q_PROPERTY(QColor kGray7 READ kGray7 NOTIFY kGray7Changed)
    Q_PROPERTY(QColor kGray8 READ kGray8 NOTIFY kGray8Changed)
    Q_PROPERTY(QColor kGray9 READ kGray9 NOTIFY kGray9Changed)
    Q_PROPERTY(QColor kGray10 READ kGray10 NOTIFY kGray10Changed)
    Q_PROPERTY(QColor kGray11 READ kGray11 NOTIFY kGray11Changed)
    Q_PROPERTY(QColor kGray12 READ kGray12 NOTIFY kGray12Changed)
    Q_PROPERTY(QColor kGray13 READ kGray13 NOTIFY kGray13Changed)
    Q_PROPERTY(QColor kGray14 READ kGray14 NOTIFY kGray14Changed)
    Q_PROPERTY(QColor kGray15 READ kGray15 NOTIFY kGray15Changed)
    Q_PROPERTY(QColor kGray16 READ kGray16 NOTIFY kGray16Changed)
    Q_PROPERTY(QColor kGray17 READ kGray17 NOTIFY kGray17Changed)
    Q_PROPERTY(QColor kGrayAlpha0 READ kGrayAlpha0 NOTIFY kGrayAlpha0Changed)
    Q_PROPERTY(QColor kGrayAlpha1 READ kGrayAlpha1 NOTIFY kGrayAlpha1Changed)
    Q_PROPERTY(QColor kGrayAlpha2 READ kGrayAlpha2 NOTIFY kGrayAlpha2Changed)
    Q_PROPERTY(QColor kGrayAlpha3 READ kGrayAlpha3 NOTIFY kGrayAlpha3Changed)
    Q_PROPERTY(QColor kGrayAlpha4 READ kGrayAlpha4 NOTIFY kGrayAlpha4Changed)
    Q_PROPERTY(QColor kGrayAlpha5 READ kGrayAlpha5 NOTIFY kGrayAlpha5Changed)
    Q_PROPERTY(QColor kGrayAlpha6 READ kGrayAlpha6 NOTIFY kGrayAlpha6Changed)
    Q_PROPERTY(QColor kGrayAlpha7 READ kGrayAlpha7 NOTIFY kGrayAlpha7Changed)
    Q_PROPERTY(QColor kGrayAlpha8 READ kGrayAlpha8 NOTIFY kGrayAlpha8Changed)
    Q_PROPERTY(QColor kGrayAlpha9 READ kGrayAlpha9 NOTIFY kGrayAlpha9Changed)
    Q_PROPERTY(QColor kGrayAlpha10 READ kGrayAlpha10 NOTIFY kGrayAlpha10Changed)
    Q_PROPERTY(QColor kGrayAlpha11 READ kGrayAlpha11 NOTIFY kGrayAlpha11Changed)
    Q_PROPERTY(QColor kGrayAlpha12 READ kGrayAlpha12 NOTIFY kGrayAlpha12Changed)
    Q_PROPERTY(QColor kGrayAlpha13 READ kGrayAlpha13 NOTIFY kGrayAlpha13Changed)
    Q_PROPERTY(QColor kFontStrong READ kFontStrong NOTIFY kFontStrongChanged)
    Q_PROPERTY(QColor kFontPrimary READ kFontPrimary NOTIFY kFontPrimaryChanged)
    Q_PROPERTY(QColor kFontPrimaryDisable READ kFontPrimaryDisable NOTIFY kFontPrimaryDisableChanged)
    Q_PROPERTY(QColor kFontSecondary READ kFontSecondary NOTIFY kFontSecondaryChanged)
    Q_PROPERTY(QColor kFontSecondaryDisable READ kFontSecondaryDisable NOTIFY kFontSecondaryDisableChanged)
    Q_PROPERTY(QColor kFontWhite READ kFontWhite NOTIFY kFontWhiteChanged)
    Q_PROPERTY(QColor kFontWhiteDisable READ kFontWhiteDisable NOTIFY kFontWhiteDisableChanged)
    Q_PROPERTY(QColor kFontWhiteSecondary READ kFontWhiteSecondary NOTIFY kFontWhiteSecondaryChanged)
    Q_PROPERTY(QColor kFontWhiteSecondaryDisable READ kFontWhiteSecondaryDisable NOTIFY kFontWhiteSecondaryDisableChanged)
    Q_PROPERTY(QColor kBrandNormal READ kBrandNormal NOTIFY kBrandNormalChanged)
    Q_PROPERTY(QColor kBrandHover READ kBrandHover NOTIFY kBrandHoverChanged)
    Q_PROPERTY(QColor kBrandClick READ kBrandClick NOTIFY kBrandClickChanged)
    Q_PROPERTY(QColor kBrandFocus READ kBrandFocus NOTIFY kBrandFocusChanged)
    Q_PROPERTY(QColor kSuccessNormal READ kSuccessNormal NOTIFY kSuccessNormalChanged)
    Q_PROPERTY(QColor kSuccessHover READ kSuccessHover NOTIFY kSuccessHoverChanged)
    Q_PROPERTY(QColor kSuccessClick READ kSuccessClick NOTIFY kSuccessClickChanged)
    Q_PROPERTY(QColor kWarningNormal READ kWarningNormal NOTIFY kWarningNormalChanged)
    Q_PROPERTY(QColor kWarningHover READ kWarningHover NOTIFY kWarningHoverChanged)
    Q_PROPERTY(QColor kWarningClick READ kWarningClick NOTIFY kWarningClickChanged)
    Q_PROPERTY(QColor kErrorNormal READ kErrorNormal NOTIFY kErrorNormalChanged)
    Q_PROPERTY(QColor kErrorHover READ kErrorHover NOTIFY kErrorHoverChanged)
    Q_PROPERTY(QColor kErrorClick READ kErrorClick NOTIFY kErrorClickChanged)
    Q_PROPERTY(QColor kBrand1 READ kBrand1 NOTIFY kBrand1Changed)
    Q_PROPERTY(QColor kBrand2 READ kBrand2 NOTIFY kBrand2Changed)
    Q_PROPERTY(QColor kBrand3 READ kBrand3 NOTIFY kBrand3Changed)
    Q_PROPERTY(QColor kBrand4 READ kBrand4 NOTIFY kBrand4Changed)
    Q_PROPERTY(QColor kBrand5 READ kBrand5 NOTIFY kBrand5Changed)
    Q_PROPERTY(QColor kBrand6 READ kBrand6 NOTIFY kBrand6Changed)
    Q_PROPERTY(QColor kBrand7 READ kBrand7 NOTIFY kBrand7Changed)
    Q_PROPERTY(QColor kContainHover READ kContainHover NOTIFY kContainHoverChanged)
    Q_PROPERTY(QColor kContainClick READ kContainClick NOTIFY kContainClickChanged)
    Q_PROPERTY(QColor kContainGeneralNormal READ kContainGeneralNormal NOTIFY kContainGeneralNormalChanged)
    Q_PROPERTY(QColor kContainSecondaryNormal READ kContainSecondaryNormal NOTIFY kContainSecondaryNormalChanged)
    Q_PROPERTY(QColor kContainSecondaryAlphaNormal READ kContainSecondaryAlphaNormal NOTIFY kContainSecondaryAlphaNormalChanged)
    Q_PROPERTY(QColor kContainSecondaryAlphaHover READ kContainSecondaryAlphaHover NOTIFY kContainSecondaryAlphaHoverChanged)
    Q_PROPERTY(QColor kContainSecondaryAlphaClick READ kContainSecondaryAlphaClick NOTIFY kContainSecondaryAlphaClickChanged)
    Q_PROPERTY(QColor kComponentNormal READ kComponentNormal NOTIFY kComponentNormalChanged)
    Q_PROPERTY(QColor kComponentHover READ kComponentHover NOTIFY kComponentHoverChanged)
    Q_PROPERTY(QColor kComponentClick READ kComponentClick NOTIFY kComponentClickChanged)
    Q_PROPERTY(QColor kComponentDisable READ kComponentDisable NOTIFY kComponentDisableChanged)
    Q_PROPERTY(QColor kComponentAlphaNormal READ kComponentAlphaNormal NOTIFY kComponentAlphaNormalChanged)
    Q_PROPERTY(QColor kComponentAlphaHover READ kComponentAlphaHover NOTIFY kComponentAlphaHoverChanged)
    Q_PROPERTY(QColor kComponentAlphaClick READ kComponentAlphaClick NOTIFY kComponentAlphaClickChanged)
    Q_PROPERTY(QColor kComponentAlphaDisable READ kComponentAlphaDisable NOTIFY kComponentAlphaDisableChanged)
    Q_PROPERTY(QColor kLineWindow  READ kLineWindow NOTIFY kLineWindowChanged)
    Q_PROPERTY(QColor kLineWindowActive READ kLineWindowActive NOTIFY kLineWindowActiveChanged)
    Q_PROPERTY(QColor kLineNormalAlpha READ kLineNormalAlpha NOTIFY kLineNormalAlphaChanged)
    Q_PROPERTY(QColor kLineDisableAlpha READ kLineDisableAlpha NOTIFY kLineDisableAlphaChanged)
    Q_PROPERTY(QColor kLineComponentNormal READ kLineComponentNormal NOTIFY kLineComponentNormalChanged)
    Q_PROPERTY(QColor kLineComponentHover READ kLineComponentHover NOTIFY kLineComponentHoverChanged)
    Q_PROPERTY(QColor kLineComponentClick READ kLineComponentClick NOTIFY kLineComponentClickChanged)
    Q_PROPERTY(QColor kLineComponentDisable READ kLineComponentDisable NOTIFY kLineComponentDisableChanged)
    Q_PROPERTY(QColor kLineBrandNormal READ kLineBrandNormal NOTIFY kLineBrandNormalChanged)
    Q_PROPERTY(QColor kLineBrandHover READ kLineBrandHover NOTIFY kLineBrandHoverChanged)
    Q_PROPERTY(QColor kLineBrandClick READ kLineBrandClick NOTIFY kLineBrandClickChanged)
    Q_PROPERTY(QColor kLineBrandDisable READ kLineBrandDisable NOTIFY kLineBrandDisableChanged)
    Q_PROPERTY(QColor kModalMask READ kModalMask NOTIFY kModalMaskChanged)
    Q_PROPERTY(int normalLine READ normalLine NOTIFY normalLineChanged)
    Q_PROPERTY(int focusLine READ focusLine NOTIFY focusLineChanged)
    Q_PROPERTY(int kRadiusMin READ kRadiusMin NOTIFY kRadiusMinChanged)
    Q_PROPERTY(int kRadiusNormal  READ kRadiusNormal NOTIFY kRadiusNormalChanged)
    Q_PROPERTY(int kRadiusMenu READ kRadiusMenu NOTIFY kRadiusMenuChanged)
    Q_PROPERTY(int kRadiusWindow READ kRadiusWindow NOTIFY kRadiusWindowChanged)
    Q_PROPERTY(int kMarginMin  READ kMarginMin NOTIFY kMarginMinChanged)
    Q_PROPERTY(int kMarginNormal READ kMarginNormal NOTIFY kMarginNormalChanged)
    Q_PROPERTY(int kMarginBig READ kMarginBig NOTIFY kMarginBigChanged)
    Q_PROPERTY(int kMarginWindow READ kMarginWindow NOTIFY kMarginWindowChanged)
    Q_PROPERTY(int kMarginComponent READ kMarginComponent NOTIFY kMarginComponentChanged)
    Q_PROPERTY(int kPaddingMinLeft READ kPaddingMinLeft NOTIFY kPaddingMinLeftChanged)
    Q_PROPERTY(int kPaddingMinRight READ kPaddingMinRight NOTIFY kPaddingMinRightChanged)
    Q_PROPERTY(int kPaddingMinTop READ kPaddingMinTop NOTIFY kPaddingMinTopChanged)
    Q_PROPERTY(int kPaddingMinBottom READ kPaddingMinBottom NOTIFY kPaddingMinBottomChanged)
    Q_PROPERTY(int kPaddingNormalLeft READ kPaddingNormalLeft NOTIFY kPaddingNormalLeftChanged)
    Q_PROPERTY(int kPaddingNormalRight READ kPaddingNormalRight NOTIFY kPaddingNormalRightChanged)
    Q_PROPERTY(int kPaddingNormalTop READ kPaddingNormalTop NOTIFY kPaddingNormalTopChanged)
    Q_PROPERTY(int kPaddingNormalBottom READ kPaddingNormalBottom NOTIFY kPaddingNormalBottomChanged)
    Q_PROPERTY(int kPadding8Left READ kPadding8Left NOTIFY kPadding8LeftChanged)
    Q_PROPERTY(int kPadding8Right READ kPadding8Right NOTIFY kPadding8RightChanged)
    Q_PROPERTY(int kPadding8Top READ kPadding8Top NOTIFY kPadding8TopChanged)
    Q_PROPERTY(int kPadding8Bottom READ kPadding8Bottom NOTIFY kPadding8BottomChanged)
    Q_PROPERTY(int kPaddingWindowLeft READ kPaddingWindowLeft NOTIFY kPaddingWindowLeftChanged)
    Q_PROPERTY(int kPaddingWindowRight READ kPaddingWindowRight NOTIFY kPaddingWindowRightChanged)
    Q_PROPERTY(int kPaddingWindowTop READ kPaddingWindowTop NOTIFY kPaddingWindowTopChanged)
    Q_PROPERTY(int kPaddingWindowBottom READ kPaddingWindowBottom NOTIFY kPaddingWindowBottomChanged)

public:
    DtTheme(QQmlEngine *engine, QObject *parent = nullptr);
    ~DtTheme();

    QColor windowTextActive() const;
    QColor windowTextInactive() const;
    QColor windowTextDisable() const;
    QColor buttonActive() const;
    QColor buttonInactive() const;
    QColor buttonDisable() const;
    QColor lightActive() const;
    QColor lightInactive() const;
    QColor lightDisable() const;
    QColor midLightActive() const;
    QColor midLightInactive() const;
    QColor midLightDisable() const;
    QColor darkActive() const;
    QColor darkInactive() const;
    QColor darkDisable() const;
    QColor midActive() const;
    QColor midInactive() const;
    QColor midDisable() const;
    QColor textActive() const;
    QColor textInactive() const;
    QColor textDisable() const;
    QColor brightTextActive() const;
    QColor brightTextInactive() const;
    QColor brightTextDisable() const;
    QColor buttonTextActive() const;
    QColor buttonTextInactive() const;
    QColor buttonTextDisable() const;
    QColor baseActive() const;
    QColor baseInactive() const;
    QColor baseDisable() const;
    QColor windowActive() const;
    QColor windowInactive() const;
    QColor windowDisable() const;
    QColor shadowActive() const;
    QColor shadowInactive() const;
    QColor shadowDisable() const;
    QColor highlightActive() const;
    QColor highlightInactive() const;
    QColor highlightDisable() const;
    QColor highlightedTextActive() const;
    QColor highlightedTextInactive() const;
    QColor highlightedTextDisable() const;
    QColor linkActive() const;
    QColor linkInactive() const;
    QColor linkDisable() const;
    QColor linkVisitedActive() const;
    QColor linkVisitedInactive() const;
    QColor linkVisitedDisable() const;
    QColor alternateBaseActive() const;
    QColor alternateBaseInactive() const;
    QColor alternateBaseDisable() const;
    QColor noRoleActive() const;
    QColor noRoleInactive() const;
    QColor noRoleDisable() const;
    QColor toolTipBaseActive() const;
    QColor toolTipBaseInactive() const;
    QColor toolTipBaseDisable() const;
    QColor toolTipTextActive() const;
    QColor toolTipTextInactive() const;
    QColor toolTipTextDisable() const;
    QColor placeholderTextActive() const;
    QColor placeholderTextInactive() const;
    QColor placeholderTextDisable() const;

    QColor kWhite() const;
    QColor kBlack() const;
    QColor kGray0() const;
    QColor kGray1() const;
    QColor kGray2() const;
    QColor kGray3() const;
    QColor kGray4() const;
    QColor kGray5() const;
    QColor kGray6() const;
    QColor kGray7() const;
    QColor kGray8() const;
    QColor kGray9() const;
    QColor kGray10() const;
    QColor kGray11() const;
    QColor kGray12() const;
    QColor kGray13() const;
    QColor kGray14() const;
    QColor kGray15() const;
    QColor kGray16() const;
    QColor kGray17() const;
    QColor kGrayAlpha0() const;
    QColor kGrayAlpha1() const;
    QColor kGrayAlpha2() const;
    QColor kGrayAlpha3() const;
    QColor kGrayAlpha4() const;
    QColor kGrayAlpha5() const;
    QColor kGrayAlpha6() const;
    QColor kGrayAlpha7() const;
    QColor kGrayAlpha8() const;
    QColor kGrayAlpha9() const;
    QColor kGrayAlpha10() const;
    QColor kGrayAlpha11() const;
    QColor kGrayAlpha12() const;
    QColor kGrayAlpha13() const;

    QColor kFontStrong() const;
    QColor kFontPrimary() const;
    QColor kFontPrimaryDisable() const;
    QColor kFontSecondary() const;
    QColor kFontSecondaryDisable() const;
    QColor kFontWhite() const;
    QColor kFontWhiteDisable() const;
    QColor kFontWhiteSecondary() const;
    QColor kFontWhiteSecondaryDisable() const;

    QColor kBrandNormal() const;
    QColor kBrandHover() const;
    QColor kBrandClick() const;
    QColor kBrandFocus() const;
    QColor kSuccessNormal() const;
    QColor kSuccessHover() const;
    QColor kSuccessClick() const;
    QColor kWarningNormal() const;
    QColor kWarningHover() const;
    QColor kWarningClick() const;
    QColor kErrorNormal() const;
    QColor kErrorHover() const;
    QColor kErrorClick() const;
    QColor kBrand1() const;
    QColor kBrand2() const;
    QColor kBrand3() const;
    QColor kBrand4() const;
    QColor kBrand5() const;
    QColor kBrand6() const;
    QColor kBrand7() const;

    QColor kContainHover() const;
    QColor kContainClick() const;
    QColor kContainGeneralNormal() const;
    QColor kContainSecondaryNormal() const;
    QColor kContainSecondaryAlphaNormal() const;
    QColor kContainSecondaryAlphaHover() const;
    QColor kContainSecondaryAlphaClick() const;
    QColor kComponentNormal() const;
    QColor kComponentHover() const;
    QColor kComponentClick() const;
    QColor kComponentDisable() const;
    QColor kComponentAlphaNormal() const;
    QColor kComponentAlphaHover() const;
    QColor kComponentAlphaClick() const;
    QColor kComponentAlphaDisable() const;
    QColor kLineWindow() const;
    QColor kLineWindowActive() const;
    QColor kLineNormalAlpha() const;
    QColor kLineDisableAlpha() const;
    QColor kLineComponentNormal() const;
    QColor kLineComponentHover() const;
    QColor kLineComponentClick() const;
    QColor kLineComponentDisable() const;
    QColor kLineBrandNormal() const;
    QColor kLineBrandHover() const;
    QColor kLineBrandClick() const;
    QColor kLineBrandDisable() const;
    QColor kModalMask() const;
    int normalLine() const;
    int focusLine() const;
    int kRadiusMin() const;
    int kRadiusNormal() const;
    int kRadiusMenu() const;
    int kRadiusWindow() const;
    int kMarginMin() const;
    int kMarginNormal() const;
    int kMarginBig() const;
    int kMarginWindow() const;
    int kMarginComponent() const;
    int kPaddingMinLeft() const;
    int kPaddingMinTop() const;
    int kPaddingMinRight() const;
    int kPaddingMinBottom() const;
    int kPaddingNormalLeft() const;
    int kPaddingNormalTop() const;
    int kPaddingNormalRight() const;
    int kPaddingNormalBottom() const;
    int kPadding8Left() const;
    int kPadding8Top() const;
    int kPadding8Right() const;
    int kPadding8Bottom() const;
    int kPaddingWindowLeft() const;
    int kPaddingWindowTop() const;
    int kPaddingWindowRight() const;
    int kPaddingWindowBottom() const;

private:
    void proportySet();
    void addFuncPointer();
    void setTheme();
    void windowTextActiveSet(QVariant value);
    void windowTextInactiveSet(QVariant value);
    void windowTextDisableSet(QVariant value);
    void buttonActiveSet(QVariant value);
    void buttonInactiveSet(QVariant value);
    void buttonDisableSet(QVariant value);
    void lightActiveSet(QVariant value);
    void lightInactiveSet(QVariant value);
    void lightDisableSet(QVariant value);
    void midLightActiveSet(QVariant value);
    void midLightInactiveSet(QVariant value);
    void midLightDisableSet(QVariant value);
    void darkActiveSet(QVariant value);
    void darkInactiveSet(QVariant value);
    void darkDisableSet(QVariant value);
    void midActiveSet(QVariant value);
    void midInactiveSet(QVariant value);
    void midDisableSet(QVariant value);
    void textActiveSet(QVariant value);
    void textInactiveSet(QVariant value);
    void textDisableSet(QVariant value);
    void brightTextActiveSet(QVariant value);
    void brightTextInactiveSet(QVariant value);
    void brightTextDisableSet(QVariant value);
    void buttonTextActiveSet(QVariant value);
    void buttonTextInactiveSet(QVariant value);
    void buttonTextDisableSet(QVariant value);
    void baseActiveSet(QVariant value);
    void baseInactiveSet(QVariant value);
    void baseDisableSet(QVariant value);
    void windowActiveSet(QVariant value);
    void windowInactiveSet(QVariant value);
    void windowDisableSet(QVariant value);
    void shadowActiveSet(QVariant value);
    void shadowInactiveSet(QVariant value);
    void shadowDisableSet(QVariant value);
    void highlightActiveSet(QVariant value);
    void highlightInactiveSet(QVariant value);
    void highlightDisableSet(QVariant value);
    void highlightedTextActiveSet(QVariant value);
    void highlightedTextInactiveSet(QVariant value);
    void highlightedTextDisableSet(QVariant value);
    void linkActiveSet(QVariant value);
    void linkInactiveSet(QVariant value);
    void linkDisableSet(QVariant value);
    void linkVisitedActiveSet(QVariant value);
    void linkVisitedInactiveSet(QVariant value);
    void linkVisitedDisableSet(QVariant value);
    void alternateBaseActiveSet(QVariant value);
    void alternateBaseInactiveSet(QVariant value);
    void alternateBaseDisableSet(QVariant value);
    void noRoleActiveSet(QVariant value);
    void noRoleInactiveSet(QVariant value);
    void noRoleDisableSet(QVariant value);
    void toolTipBaseActiveSet(QVariant value);
    void toolTipBaseInactiveSet(QVariant value);
    void toolTipBaseDisableSet(QVariant value);
    void toolTipTextActiveSet(QVariant value);
    void toolTipTextInactiveSet(QVariant value);
    void toolTipTextDisableSet(QVariant value);
    void placeholderTextActiveSet(QVariant value);
    void placeholderTextInactiveSet(QVariant value);
    void placeholderTextDisableSet(QVariant value);

    void kWhiteSet(QVariant value);
    void kBlackSet(QVariant value);
    void kGray0Set(QVariant value);
    void kGray1Set(QVariant value);
    void kGray2Set(QVariant value);
    void kGray3Set(QVariant value);
    void kGray4Set(QVariant value);
    void kGray5Set(QVariant value);
    void kGray6Set(QVariant value);
    void kGray7Set(QVariant value);
    void kGray8Set(QVariant value);
    void kGray9Set(QVariant value);
    void kGray10Set(QVariant value);
    void kGray11Set(QVariant value);
    void kGray12Set(QVariant value);
    void kGray13Set(QVariant value);
    void kGray14Set(QVariant value);
    void kGray15Set(QVariant value);
    void kGray16Set(QVariant value);
    void kGray17Set(QVariant value);
    void kGrayAlpha0Set(QVariant value);
    void kGrayAlpha1Set(QVariant value);
    void kGrayAlpha2Set(QVariant value);
    void kGrayAlpha3Set(QVariant value);
    void kGrayAlpha4Set(QVariant value);
    void kGrayAlpha5Set(QVariant value);
    void kGrayAlpha6Set(QVariant value);
    void kGrayAlpha7Set(QVariant value);
    void kGrayAlpha8Set(QVariant value);
    void kGrayAlpha9Set(QVariant value);
    void kGrayAlpha10Set(QVariant value);
    void kGrayAlpha11Set(QVariant value);
    void kGrayAlpha12Set(QVariant value);
    void kGrayAlpha13Set(QVariant value);

    void kFontStrongSet(QVariant value);
    void kFontPrimarySet(QVariant value);
    void kFontPrimaryDisableSet(QVariant value);
    void kFontSecondarySet(QVariant value);
    void kFontSecondaryDisableSet(QVariant value);
    void kFontWhiteSet(QVariant value);
    void kFontWhiteDisableSet(QVariant value);
    void kFontWhiteSecondarySet(QVariant value);
    void kFontWhiteSecondaryDisableSet(QVariant value);

    void kBrandNormalSet(QVariant value);
    void kBrandHoverSet(QVariant value);
    void kBrandClickSet(QVariant value);
    void kBrandFocusSet(QVariant value);
    void kSuccessNormalSet(QVariant value);
    void kSuccessHoverSet(QVariant value);
    void kSuccessClickSet(QVariant value);
    void kWarningNormalSet(QVariant value);
    void kWarningHoverSet(QVariant value);
    void kWarningClickSet(QVariant value);
    void kErrorNormalSet(QVariant value);
    void kErrorHoverSet(QVariant value);
    void kErrorClickSet(QVariant value);
    void kBrand1Set(QVariant value);
    void kBrand2Set(QVariant value);
    void kBrand3Set(QVariant value);
    void kBrand4Set(QVariant value);
    void kBrand5Set(QVariant value);
    void kBrand6Set(QVariant value);
    void kBrand7Set(QVariant value);

    void kContainHoverSet(QVariant value);
    void kContainClickSet(QVariant value);
    void kContainGeneralNormalSet(QVariant value);
    void kContainSecondaryNormalSet(QVariant value);
    void kContainSecondaryAlphaNormalSet(QVariant value);
    void kContainSecondaryAlphaHoverSet(QVariant value);
    void kContainSecondaryAlphaClickSet(QVariant value);
    void kComponentNormalSet(QVariant value);
    void kComponentHoverSet(QVariant value);
    void kComponentClickSet(QVariant value);
    void kComponentDisableSet(QVariant value);
    void kComponentAlphaNormalSet(QVariant value);
    void kComponentAlphaHoverSet(QVariant value);
    void kComponentAlphaClickSet(QVariant value);
    void kComponentAlphaDisableSet(QVariant value);
    void kLineWindowSet(QVariant value);
    void kLineWindowActiveSet(QVariant value);
    void kLineNormalAlphaSet(QVariant value);
    void kLineDisableAlphaSet(QVariant value);
    void kLineComponentNormalSet(QVariant value);
    void kLineComponentHoverSet(QVariant value);
    void kLineComponentClickSet(QVariant value);
    void kLineComponentDisableSet(QVariant value);
    void kLineBrandNormalSet(QVariant value);
    void kLineBrandHoverSet(QVariant value);
    void kLineBrandClickSet(QVariant value);
    void kLineBrandDisableSet(QVariant value);
    void kModalMaskSet(QVariant value);
    void normalLineSet(QVariant value);
    void focusLineSet(QVariant value);
    void kRadiusMinSet(QVariant value);
    void kRadiusNormalSet(QVariant value);
    void kRadiusMenuSet(QVariant value);
    void kRadiusWindowSet(QVariant value);
    void kMarginMinSet(QVariant value);
    void kMarginNormalSet(QVariant value);
    void kMarginBigSet(QVariant value);
    void kMarginWindowSet(QVariant value);
    void kMarginComponentSet(QVariant value);
    void kPaddingMinLeftSet(QVariant value);
    void kPaddingMinTopSet(QVariant value);
    void kPaddingMinRightSet(QVariant value);
    void kPaddingMinBottomSet(QVariant value);
    void kPaddingNormalLeftSet(QVariant value);
    void kPaddingNormalTopSet(QVariant value);
    void kPaddingNormalRightSet(QVariant value);
    void kPaddingNormalBottomSet(QVariant value);
    void kPadding8LeftSet(QVariant value);
    void kPadding8TopSet(QVariant value);
    void kPadding8RightSet(QVariant value);
    void kPadding8BottomSet(QVariant value);
    void kPaddingWindowLeftSet(QVariant value);
    void kPaddingWindowTopSet(QVariant value);
    void kPaddingWindowRightSet(QVariant value);
    void kPaddingWindowBottomSet(QVariant value);

Q_SIGNALS:
    void windowTextActiveChanged();
    void windowTextInactiveChanged();
    void windowTextDisableChanged();
    void buttonActiveChanged();
    void buttonInactiveChanged();
    void buttonDisableChanged();
    void lightActiveChanged();
    void lightInactiveChanged();
    void lightDisableChanged();
    void midLightActiveChanged();
    void midLightInactiveChanged();
    void midLightDisableChanged();
    void darkActiveChanged();
    void darkInactiveChanged();
    void darkDisableChanged();
    void midActiveChanged();
    void midInactiveChanged();
    void midDisableChanged();
    void textActiveChanged();
    void textInactiveChanged();
    void textDisableChanged();
    void brightTextActiveChanged();
    void brightTextInactiveChanged();
    void brightTextDisableChanged();
    void buttonTextActiveChanged();
    void buttonTextInactiveChanged();
    void buttonTextDisableChanged();
    void baseActiveChanged();
    void baseInactiveChanged();
    void baseDisableChanged();
    void windowActiveChanged();
    void windowInactiveChanged();
    void windowDisableChanged();
    void shadowActiveChanged();
    void shadowInactiveChanged();
    void shadowDisableChanged();
    void highlightActiveChanged();
    void highlightInactiveChanged();
    void highlightDisableChanged();
    void highlightedTextActiveChanged();
    void highlightedTextInactiveChanged();
    void highlightedTextDisableChanged();
    void linkActiveChanged();
    void linkInactiveChanged();
    void linkDisableChanged();
    void linkVisitedActiveChanged();
    void linkVisitedInactiveChanged();
    void linkVisitedDisableChanged();
    void alternateBaseActiveChanged();
    void alternateBaseInactiveChanged();
    void alternateBaseDisableChanged();
    void noRoleActiveChanged();
    void noRoleInactiveChanged();
    void noRoleDisableChanged();
    void toolTipBaseActiveChanged();
    void toolTipBaseInactiveChanged();
    void toolTipBaseDisableChanged();
    void toolTipTextActiveChanged();
    void toolTipTextInactiveChanged();
    void toolTipTextDisableChanged();
    void placeholderTextActiveChanged();
    void placeholderTextInactiveChanged();
    void placeholderTextDisableChanged();

    void kWhiteChanged();
    void kBlackChanged();
    void kGray0Changed();
    void kGray1Changed();
    void kGray2Changed();
    void kGray3Changed();
    void kGray4Changed();
    void kGray5Changed();
    void kGray6Changed();
    void kGray7Changed();
    void kGray8Changed();
    void kGray9Changed();
    void kGray10Changed();
    void kGray11Changed();
    void kGray12Changed();
    void kGray13Changed();
    void kGray14Changed();
    void kGray15Changed();
    void kGray16Changed();
    void kGray17Changed();
    void kGrayAlpha0Changed();
    void kGrayAlpha1Changed();
    void kGrayAlpha2Changed();
    void kGrayAlpha3Changed();
    void kGrayAlpha4Changed();
    void kGrayAlpha5Changed();
    void kGrayAlpha6Changed();
    void kGrayAlpha7Changed();
    void kGrayAlpha8Changed();
    void kGrayAlpha9Changed();
    void kGrayAlpha10Changed();
    void kGrayAlpha11Changed();
    void kGrayAlpha12Changed();
    void kGrayAlpha13Changed();

    void kFontStrongChanged();
    void kFontPrimaryChanged();
    void kFontPrimaryDisableChanged();
    void kFontSecondaryChanged();
    void kFontSecondaryDisableChanged();
    void kFontWhiteChanged();
    void kFontWhiteDisableChanged();
    void kFontWhiteSecondaryChanged();
    void kFontWhiteSecondaryDisableChanged();

    void kBrandNormalChanged();
    void kBrandHoverChanged();
    void kBrandClickChanged();
    void kBrandFocusChanged();
    void kSuccessNormalChanged();
    void kSuccessHoverChanged();
    void kSuccessClickChanged();
    void kWarningNormalChanged();
    void kWarningHoverChanged();
    void kWarningClickChanged();
    void kErrorNormalChanged();
    void kErrorHoverChanged();
    void kErrorClickChanged();
    void kBrand1Changed();
    void kBrand2Changed();
    void kBrand3Changed();
    void kBrand4Changed();
    void kBrand5Changed();
    void kBrand6Changed();
    void kBrand7Changed();

    void kContainHoverChanged();
    void kContainClickChanged();
    void kContainGeneralNormalChanged();
    void kContainSecondaryNormalChanged();
    void kContainSecondaryAlphaNormalChanged();
    void kContainSecondaryAlphaHoverChanged();
    void kContainSecondaryAlphaClickChanged();
    void kComponentNormalChanged();
    void kComponentHoverChanged();
    void kComponentClickChanged();
    void kComponentDisableChanged();
    void kComponentAlphaNormalChanged();
    void kComponentAlphaHoverChanged();
    void kComponentAlphaClickChanged();
    void kComponentAlphaDisableChanged();
    void kLineWindowChanged();
    void kLineWindowActiveChanged();
    void kLineNormalAlphaChanged();
    void kLineDisableAlphaChanged();
    void kLineComponentNormalChanged();
    void kLineComponentHoverChanged();
    void kLineComponentClickChanged();
    void kLineComponentDisableChanged();
    void kLineBrandNormalChanged();
    void kLineBrandHoverChanged();
    void kLineBrandClickChanged();
    void kLineBrandDisableChanged();
    void kModalMaskChanged();
    void normalLineChanged();
    void focusLineChanged();
    void kRadiusMinChanged();
    void kRadiusNormalChanged();
    void kRadiusMenuChanged();
    void kRadiusWindowChanged();
    void kMarginMinChanged();
    void kMarginNormalChanged();
    void kMarginBigChanged();
    void kMarginWindowChanged();
    void kMarginComponentChanged();
    void kPaddingMinLeftChanged();
    void kPaddingMinTopChanged();
    void kPaddingMinRightChanged();
    void kPaddingMinBottomChanged();
    void kPaddingNormalLeftChanged();
    void kPaddingNormalTopChanged();
    void kPaddingNormalRightChanged();
    void kPaddingNormalBottomChanged();
    void kPadding8LeftChanged();
    void kPadding8TopChanged();
    void kPadding8RightChanged();
    void kPadding8BottomChanged();
    void kPaddingWindowLeftChanged();
    void kPaddingWindowTopChanged();
    void kPaddingWindowRightChanged();
    void kPaddingWindowBottomChanged();
private:
    DtThemePrivate *d = nullptr;
    QMap<QString, std::function<void(QVariant)>> m_valueSet;
};
} // UkuiQuick

#endif //DT_THEME_H
